# Singularity Python

[![Build Status](https://travis-ci.org/singularityhub/singularity-cli.svg?branch=master)](https://travis-ci.org/singularityhub/singularity-cli)
[![GitHub actions status](https://github.com/singularityhub/singularity-cli/workflows/spython-ci/badge.svg?branch=master)](https://github.com/singularityhub/singularity-cli/actions?query=branch%3Amaster+workflow%3Aspython-ci)

Singularity Python (spython) is the Python API for working with <a href="https://sylabs.io/guides/latest/user-guide/" target="_blank">Singularity</a> containers. See
the [documentation](https://singularityhub.github.io/singularity-cli) for installation and usage, and
the [install instructions](https://singularityhub.github.io/singularity-cli/install) for a quick start.

**This library does not support Singularity 2.x! It won't work and we no longer support it.**

We provide a [Singularity](Singularity) recipe for you to use if more convenient, along with the [full modules docstring](https://singularityhub.github.io/singularity-cli/api/source/spython.main.base.html#module-spython.main.base).

As of version 0.1.0, we only support Singularity > 3.5.2. This is done to encourage using
newer versions of Singularity with security fixes. If you want to use an older version of Singularity,
you will need to use version 0.0.85 or earlier.

## 😁️ Contributors 😁️

We use the [all-contributors](https://github.com/all-contributors/all-contributors)
tool to generate a contributors graphic below.

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->
<table>
  <tbody>
    <tr>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/Flamefire"><img src="https://avatars.githubusercontent.com/u/309017?v=4?s=100" width="100px;" alt="Flamefire"/><br /><sub><b>Flamefire</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=Flamefire" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/kinow"><img src="https://avatars.githubusercontent.com/u/304786?v=4?s=100" width="100px;" alt="kinow"/><br /><sub><b>kinow</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=kinow" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/tschoonj"><img src="https://avatars.githubusercontent.com/u/65736?v=4?s=100" width="100px;" alt="tschoonj"/><br /><sub><b>tschoonj</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=tschoonj" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/al3x609"><img src="https://avatars.githubusercontent.com/u/4086644?v=4?s=100" width="100px;" alt="al3x609"/><br /><sub><b>al3x609</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=al3x609" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/mobiusklein"><img src="https://avatars.githubusercontent.com/u/1426041?v=4?s=100" width="100px;" alt="mobiusklein"/><br /><sub><b>mobiusklein</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=mobiusklein" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/MarDiehl"><img src="https://avatars.githubusercontent.com/u/6196733?v=4?s=100" width="100px;" alt="MarDiehl"/><br /><sub><b>MarDiehl</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=MarDiehl" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/shnizzedy"><img src="https://avatars.githubusercontent.com/u/5974438?v=4?s=100" width="100px;" alt="shnizzedy"/><br /><sub><b>shnizzedy</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=shnizzedy" title="Code">💻</a></td>
    </tr>
    <tr>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/wkpalan"><img src="https://avatars.githubusercontent.com/u/6353590?v=4?s=100" width="100px;" alt="wkpalan"/><br /><sub><b>wkpalan</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=wkpalan" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/cceyda"><img src="https://avatars.githubusercontent.com/u/15624271?v=4?s=100" width="100px;" alt="cceyda"/><br /><sub><b>cceyda</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=cceyda" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/neumann-nico"><img src="https://avatars.githubusercontent.com/u/33637944?v=4?s=100" width="100px;" alt="neumann-nico"/><br /><sub><b>neumann-nico</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=neumann-nico" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/vsoch"><img src="https://avatars.githubusercontent.com/u/814322?v=4?s=100" width="100px;" alt="vsoch"/><br /><sub><b>vsoch</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=vsoch" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/pierlauro"><img src="https://avatars.githubusercontent.com/u/6776431?v=4?s=100" width="100px;" alt="pierlauro"/><br /><sub><b>pierlauro</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=pierlauro" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/biosugar0"><img src="https://avatars.githubusercontent.com/u/18737819?v=4?s=100" width="100px;" alt="biosugar0"/><br /><sub><b>biosugar0</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=biosugar0" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/tcpan"><img src="https://avatars.githubusercontent.com/u/938025?v=4?s=100" width="100px;" alt="Tony Pan"/><br /><sub><b>Tony Pan</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=tcpan" title="Code">💻</a></td>
    </tr>
    <tr>
      <td align="center" valign="top" width="14.28%"><a href="https://github.com/tjgalvin"><img src="https://avatars.githubusercontent.com/u/10543142?v=4?s=100" width="100px;" alt="tjgalvin"/><br /><sub><b>tjgalvin</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=tjgalvin" title="Code">💻</a></td>
      <td align="center" valign="top" width="14.28%"><a href="http://www.pasteur.fr/ip/easysite/pasteur/fr/recherche/Centre-Informatique-pour-la-Biologie"><img src="https://avatars.githubusercontent.com/u/6849075?v=4?s=100" width="100px;" alt="Eric Deveaud"/><br /><sub><b>Eric Deveaud</b></sub></a><br /><a href="https://github.com/singularityhub/singularity-cli/commits?author=EricDeveaud" title="Code">💻</a></td>
    </tr>
  </tbody>
</table>

<!-- markdownlint-restore -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->



## License

This code is licensed under the MPL 2.0 [LICENSE](LICENSE).

## Help and Contribution

Please contribute to the package, or post feedback and questions as <a href="https://github.com/singularityhub/singularity-cli" target="_blank">issues</a>. For points that require discussion of the larger group, please use the <a href="https://groups.google.com/a/lbl.gov/forum/#!forum/singularity" target="_blank">Singularity List</a>
